package numarea;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import numarea.ControlDialog;

public class MainPanel extends JPanel 
{
	public	JFrame mainframe;
	public JPanel configPanel		= new JPanel();	
	public JPanel modePanel			= new JPanel();
	public JLabel bottomLabel;
	public JScrollPane gridscroll;
	public GridField gridfield;

	public	JLabel filenameLabel		= new JLabel("filename");	// ファイル名
	public JLabel pegnumLabel		= new JLabel("peg");			// ペグ数
	public JButton controlButton	= new JButton("Control Board");
	public JLabel runtimeLabel		= new JLabel("runtime");
	
	public JLabel modeLabel			= new JLabel();
	public JButton setButton			= new JButton("Set");
	public JButton cutButton			= new JButton("Cut");
	public JButton playButton		= new JButton("Play");
	public JButton solveButton		= new JButton("Solve");
	public JButton evalButton		= new JButton("Eval");
	public JButton clearButton		= new JButton("Clear");
	public JLabel  pointLabel		= new JLabel("point");			// ポイント	
	
	private ControlDialog 	controldialog;
	private DesignPanel		designdialog;
	public DesignPanel		getDesignDialog()		{	return	designdialog;		}
	
	public	void	setFilename( String name ) {
		filenameLabel.setText(name);
	}
	
	public	void	setPegNum( int n ) {
		pegnumLabel.setText(""+n);
	}

	public	void	setPoint( int n, double av ) {
		String str = String.format("%d %6.2f", n, av );
		pointLabel.setText( str );
	}

	public MainPanel( JFrame frame ) {

		mainframe = frame;
		this.setLayout(new BorderLayout());
		
		gridfield = new GridField(this);
		gridscroll = new JScrollPane(gridfield,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		this.add(gridscroll,BorderLayout.CENTER);

		// ------------------- 上側のボタン -------------------
		configPanel.add(filenameLabel);
		configPanel.add(new JLabel("    "));
		configPanel.add(pegnumLabel);
		configPanel.add(new JLabel("    "));
		configPanel.add(controlButton);
		configPanel.add(new JLabel("    "));
		configPanel.add(runtimeLabel);		
		this.add(configPanel,BorderLayout.NORTH);

		// ------------------- 下側のボタン -------------------
		modePanel.add(modeLabel);
		modePanel.add(setButton);
		modePanel.add(cutButton);
		modePanel.add(playButton);
		modePanel.add(solveButton);
		modePanel.add(clearButton);	
		modePanel.add( new JLabel("  "));
		modePanel.add(evalButton);
		modePanel.add(pointLabel);
		this.add(modePanel,BorderLayout.SOUTH);

		controlButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						if( controldialog == null ) {
							controldialog = new ControlDialog(gridfield);
						}
						controldialog.showDialog();
					}
				}
		);
		
		setButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.SETTING);							
						solveButton.setBackground(null);
						gridfield.refresh();
					}
				}
		);
		
		cutButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.CUTTING);							
						solveButton.setBackground(null);
						gridfield.refresh();
					}
				}
		);
		playButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.PLAY);							
						gridfield.refresh();
					}
				}
		);
		solveButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.SOLVE);							
						gridfield.refresh();
					}
				}
		);
		clearButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.clearBoard();							
						gridfield.refresh();
					}
				}
		);
		
		evalButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.EVAL);							
						gridfield.refresh();
					}
				}
		);
	}
	
	public	void	clearSolveButton() {
		solveButton.setBackground(null);
	}
}
