package numarea;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/* ================================================================
 *  作成　パネル
 */
public class MakePanel extends JPanel {
	private GridField gridfield;
	
	public JButton clrNumButton		= new JButton("C Num");
	public JButton genButton			= new JButton("Generate");

	public JButton clrlogButton		= new JButton("C Log");
	public	JLabel	 timeLabel			= new JLabel("time");
	
	public	JLabel	 pretotalLabel	= new JLabel("pre");
	public	JLabel	 posttotalLabel	= new JLabel("post");
	public	JLabel	 genstateLabel	= new JLabel("gen");
	
	public	JLabel	 smininfoLabel		= new JLabel("smin");
	public	JLabel	 smaxinfoLabel		= new JLabel("smax");
	
	public JButton stopButton		= new JButton("STOP");
	
	private 	JTextArea			genlogTextArea;
	
	private 	JTextField			gaselectcount	= new JTextField("10",3);
	private	JTextField			gacrosscount	= new JTextField("18",3);
	private	JTextField			gamutatecount	= new JTextField("2",3);
	
	private	JTextField			selectrate		= new JTextField("0.6",5);
	private	JTextField			agingfactor	= new JTextField("0.3",5);
	private	JTextField			parentcurve	= new JTextField("2.0",5);
	private	JTextField			parentcut		= new JTextField("1.0",5);
	private	JTextField			maxmutation	= new JTextField("15",5);
	private	JTextField			maxgeneration	= new JTextField("1000",5);
	private	JTextField			uniquedist		= new JTextField("0",2);		// ユニーク距離

	private	JCheckBox		rectprint		= new JCheckBox("Rect",true);
	private	JCheckBox		unevenprint	= new JCheckBox("UnEven",true);
	private	JCheckBox		numprint		= new JCheckBox("Num",true);
	private	JCheckBox		hidprint		= new JCheckBox("Hid",true);
	private	JCheckBox		rngprint		= new JCheckBox("Range",true);
	private	JCheckBox		timeprint		= new JCheckBox("Time", false);
	
	public		boolean	isrectprint()		{	return rectprint.isSelected();		}
	public		boolean	isunevenprint()	{	return unevenprint.isSelected();		}
	public		boolean	isnumprint()		{	return numprint.isSelected();		}
	public		boolean	ishidprint()		{	return hidprint.isSelected();		}
	public		boolean	isrngprint()		{	return rngprint.isSelected();		}
	public		boolean	istimeprint()		{	return	timeprint.isSelected();		}
	
	public	void	setprepost( int pre, int post, int bad, int gen ) {
		pretotalLabel.setText(""+pre);
		posttotalLabel.setText(""+post);
		genstateLabel.setText(bad+"/"+gen);
	}
	public	void	setselectinfo( int min, int cnt, int max ) {
		smininfoLabel.setText(min+"/"+cnt);
		smaxinfoLabel.setText(""+max);
	}

	public	void	clearprepost() {
		pretotalLabel.setText("pre");
		posttotalLabel.setText("post");
		genstateLabel.setText("gen");
		smininfoLabel.setText("smin");
		smaxinfoLabel.setText("smax");
	}
	
	public	void	setGenButtonEnabled( boolean sw ) {
		if( sw ) {		// enable
			genButton.setBackground(null);
		} else {		// disable
			genButton.setBackground(Color.GREEN);
		}
		genButton.setEnabled(sw);
	}
	
	//------------------------------------------------------------------------------------
	//	MakePanel
	//------------------------------------------------------------------------------------
	MakePanel(GridField grid) {
		this.gridfield = grid;
		grid.makepanel = this;	
		
		this.setLayout(new BorderLayout());
				
		JPanel genpanel = makeGenPanel();				// PRE
		add(genpanel,BorderLayout.NORTH);
		
		JPanel westpanel = makeWestPanel();
		add(westpanel,BorderLayout.WEST);
			
		JPanel	stoppanel = makeStopPanel();
		add(stoppanel,BorderLayout.SOUTH);
		
		JPanel	logpanel = makeLogPanel();
		add(logpanel,BorderLayout.CENTER);
	}
	
	//---------		  GEN  パネルの作成  	--------
	private JPanel	makeGenPanel() {
		JPanel panel = new JPanel();

		panel.add(clrNumButton);
		panel.add(genButton);		
		
		JPanel	panela = new JPanel();
		panela.add( new JLabel("S"));
		panela.add(gaselectcount);
		panel.add(panela);

		JPanel	panelb = new JPanel();
		panelb.add( new JLabel("C"));
		panelb.add(gacrosscount);
		panel.add(panelb);
		
		JPanel	panelc = new JPanel();
		panelc.add( new JLabel("M"));
		panelc.add(gamutatecount);
		panel.add(panelc);	
				
		clrNumButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.clearRect();
						gridfield.clearAllArea();
						gridfield.refresh();
					}
				}
		);
		
		genButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						Thread th = new Thread() {
							public	void	run() {
								gridfield.ga = new GA( gridfield );
								gridfield.ga.exec();
								setGenButtonEnabled(true);
							}
						};
						th.start();
					}
				}
		);
					
		return	panel;
	}	

	// 西側　情報出力パネル
	private JPanel makeWestPanel() {
		JPanel panel = new JPanel();
		panel.setLayout( new  BoxLayout(panel,BoxLayout.Y_AXIS) );
	
		clrlogButton.setAlignmentX(0.5f);
		panel.add(clrlogButton);
		timeLabel.setAlignmentX(0.5f);
		panel.add(timeLabel);
		
		panel.add(new JLabel(" "));
		
		pretotalLabel.setAlignmentX(0.5f);
		panel.add(pretotalLabel);
		posttotalLabel.setAlignmentX(0.5f);
		panel.add(posttotalLabel);
		genstateLabel.setAlignmentX(0.5f);
		panel.add(genstateLabel);
		
		panel.add(new JLabel(" "));
		
		smininfoLabel.setAlignmentX(0.5f);
		panel.add(smininfoLabel);
		smaxinfoLabel.setAlignmentX(0.5f);
		panel.add(smaxinfoLabel);

		panel.add(new JLabel(" "));
		
		JLabel	labels = new JLabel("select rate");
		labels.setAlignmentX(0.5f);
		panel.add(labels);
		JPanel srpanel = new JPanel();
		srpanel.add(selectrate);	
		panel.add(srpanel);
				
		JLabel	labelaf = new JLabel("aging factor");
		labelaf.setAlignmentX(0.5f);
		panel.add(labelaf);
		JPanel afpanel = new JPanel();
		afpanel.add(agingfactor);	
		panel.add(afpanel);
		
		JLabel	labelcc = new JLabel("parent curve");
		labelcc.setAlignmentX(0.5f);
		panel.add(labelcc);
		JPanel ccurpanel = new JPanel();
		ccurpanel.add(new JLabel("pow"));	
		ccurpanel.add(parentcurve);	
		panel.add(ccurpanel);
		JPanel ccutpanel = new JPanel();
		ccutpanel.add(new JLabel("cut"));	
		ccutpanel.add(parentcut);
		panel.add(ccutpanel);

		panel.add(new JLabel(" "));
		
		JLabel	labelmm = new JLabel("max mutation");
		labelmm.setAlignmentX(0.5f);
		panel.add(labelmm);
		JPanel mmpanel = new JPanel();
		mmpanel.add(maxmutation);	
		panel.add(mmpanel);		
		
		JLabel	labelmg = new JLabel("max generation");
		labelmg.setAlignmentX(0.5f);
		panel.add(labelmg);
		JPanel mgpanel = new JPanel();
		mgpanel.add(maxgeneration);	
		panel.add(mgpanel);
		
		panel.add(new JLabel(" "));
		
		JPanel uniquepanel = new JPanel();
		uniquepanel.add(new JLabel("unique dist"));
		uniquepanel.add(uniquedist);
		panel.add(uniquepanel);
		
		clrlogButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						clearlog();
					}
				});
		
		return	panel;
	}
	
	public	int		getselectcount() 		{	return	Integer.valueOf(gaselectcount.getText());	}	
	public	int		getcrosscount() 		{	return	Integer.valueOf(gacrosscount.getText());	}
	public	int		getmutatecount() 		{	return	Integer.valueOf(gamutatecount.getText());	}
	public	void	setselectcount( int n )	{	gaselectcount.setText(""+n);	}
	public	void	setcrosscount( int n )	{	gacrosscount.setText(""+n);		}
	public	void	setmutatecount( int n )	{	gamutatecount.setText(""+n);	}
	
	public	double	getselectrate()	{
		String str = selectrate.getText();
		return	Double.valueOf(str);
	}
	public	void	setselectrate( double d ) {
		selectrate.setText(""+d);
	}
	
	public	double	getagingfactor()	{
		String str = agingfactor.getText();
		return	Double.valueOf(str);
	}
	public	void	setagingfactor( double d ) {
		agingfactor.setText(""+d);
	}	
	
	public	double	getparentcurve()	{
		String str = parentcurve.getText();
		return	Double.valueOf(str);
	}
	public	void	setparentcurve( double d ) {
		parentcurve.setText(""+d);
	}
	public	double	getparentcut()	{
		String str = parentcut.getText();
		return	Double.valueOf(str);
	}
	public	void	setparentcut( double d ) {
		parentcut.setText(""+d);
	}
	
	public	int	getmaxmutation()	{
		String str = maxmutation.getText();
		return Integer.valueOf(str);
	}
	public	void	setmaxmutation( int m ) {
		maxmutation.setText(""+m);
	}	
	public	int	getmaxgeneration()	{
		String str = maxgeneration.getText();
		return Integer.valueOf(str);
	}
	public	void	setmaxgeneration( int m ) {
		maxgeneration.setText(""+m);
	}
	
	public	int	getuniquedistance()	{
		String str = uniquedist.getText();
		return Integer.valueOf(str);
	}	
	public	void	setuniquedistance( int m ) {
		uniquedist.setText(""+m);
	}
	
	private JPanel makeLogPanel() {
		JPanel panel = new JPanel();

		panel.setLayout(new BorderLayout());

		// 中央、統計結果
		Font monofont = new Font(Font.MONOSPACED, Font.BOLD, 12);
		genlogTextArea = new JTextArea();
		genlogTextArea.setFont(monofont);
		genlogTextArea.setEditable(false);
		
		JScrollPane scrollpane = new JScrollPane(genlogTextArea, 
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
                JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		panel.add(scrollpane,BorderLayout.CENTER);
			
		return	panel;
	}
	
	private JPanel makeStopPanel() {
		JPanel panel = new JPanel();
		
		panel.add(stopButton);
		stopButton.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					gridfield.setBreak(true);
					setGenButtonEnabled(true);
				}
			});
		
		panel.add( new JLabel("     "));
		panel.add( rectprint );
		panel.add( unevenprint );
		panel.add( numprint );
		panel.add( hidprint );
		panel.add( rngprint );
		panel.add( timeprint );
		
		return	panel;
	}
	
	//　ログに文字列を加える
	public	void appendlog( String str ) {
		genlogTextArea.append(str);
		genlogTextArea.setCaretPosition(genlogTextArea.getDocument().getLength());
	}
	
	public void clearlog() {
		genlogTextArea.setText("");
	}
	
	public	void setexectime( int sec ) {
		int	ss = sec % 60;
		int mm = (sec/60) % 60;
		int hh = sec /60/60;
		String	str = String.format( "%02d:%02d:%02d", hh, mm, ss  );
		
		timeLabel.setText( str );
	}
}