package numarea;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Random;

public class Util {
	public 	static	Random rand = new Random(System.currentTimeMillis());
	
	// 2つのマスを含む長方形を作って返す
	public static Rectangle makeRectangle( Point p1, Point p2 ) {
		int x = Math.min(p1.x, p2.x );
		int y = Math.min(p1.y, p2.y );
		int w = Math.abs(p1.x - p2.x) + 1;
		int h = Math.abs(p1.y - p2.y) + 1;	
		return	new Rectangle( x, y, w, h );
	}
	
	public static Rectangle makeRectangle( Rectangle r, Point p ) {
		Rectangle pr = new Rectangle( p.x, p.y, 1, 1);
		return	r.union( pr );
	}
	
	public	static	boolean isInside( Point p, int w, int h ) {
		if( p.x <= 0 || w-2 < p.x )
			return	false;
		if( p.y <= 0 || h-2 < p.y )
			return	false;
		
		return	true;

	}
	
	public static boolean isOn( Point p, int w, int h ) {
		if( p.x < 0 || w <= p.x )
			return	false;
		if( p.y< 0 || h <= p.y )
			return	false;
		
		return	true;
	}	
	
	// 面積を与えて、可能な長方形の２辺の長さの組のリスト
	public static	ArrayList<Dimension>	getCombinations( int num ) {
		ArrayList<Dimension> comb = new ArrayList<Dimension>();
		for( int i=1; i<=num; ++i ) {
			int j = num / i;
			if( i * j == num ) {
				comb.add( new Dimension(i,j) );
			}
		}	
		
		return comb;
	}
	
	public static	Rectangle getCommonRectangle( ArrayList<Rectangle> recs ) {
		if( recs == null )
			return	null;
		if( recs.size() == 0 )
			return	null;
		Rectangle common = new Rectangle( recs.get(0));
		for( int i=1; i<recs.size(); ++i ) {
			common = getCommonRectangle( common, recs.get(i) );
		}
		return	common;
	}
	
	public static Rectangle getCommonRectangle( Rectangle r1, Rectangle r2 ) {
		if( r1 == null || r2 == null )
			return	null;
		return	r1.intersection(r2);
	}
	
	public	static	boolean[][] deepcopy( boolean[][] org ) {
		boolean[][] cpy	=	new boolean[org.length][org[0].length];
		for( int i=0; i<org.length;++i )
			for( int j=0; j<org[0].length; ++j )
				cpy[i][j] = org[i][j];
		return	cpy;
	}
}

// ソルバーの矛盾
class	ConflictExceptoin extends Exception {
	public	String errMessage;
	ConflictExceptoin( String msg ) {
		errMessage = msg;
	}	
	public	void print() {
		System.out.println("ConflictExceptoin:"+errMessage);
	}
}
